use std::collections::HashMap;

pub fn showroom() {
    println!("Calculate the Mean, Median and Mode of some vectors");

    let v = vec![1, 2, 8, 5, 1, 9, 5, 4, 6, 5, 5];
    println!("Vector: {:?}", v);
    match mean(&v) {
        Some(x) => println!("Mean: {:?}", x),
        None => println!("Not possible to process the Mean of this Vec<T>."),
    }
    match median(&v) {
        Some(x) => println!("Median: {:?}", x),
        None => println!("Not possible to process the Median of this Vec<T>."),
    }
    match mode(&v) {
        Some(x) => println!("Modes: {:?}", x),
        None => println!("Not possible to process the Modes of this Vec<T>."),
    }

    let v = vec![1, 2, 8, 7, 8, 6, 7, 5, 1, 9, 5, 4, 6, 5, 5, 9, 9, 9, 9];
    println!("Vector: {:?}", v);
    match mean(&v) {
        Some(x) => println!("Mean: {:?}", x),
        None => println!("Not possible to process the Mean of this Vec<T>."),
    }
    match median(&v) {
        Some(x) => println!("Median: {:?}", x),
        None => println!("Not possible to process the Median of this Vec<T>."),
    }
    match mode(&v) {
        Some(x) => println!("Modes: {:?}", x),
        None => println!("Not possible to process the Modes of this Vec<T>."),
    }

    let v = vec![];
    println!("Vector: {:?}", v);
    match mean(&v) {
        Some(x) => println!("Mean: {:?}", x),
        None => println!("Not possible to process the Mean of this Vec<T>."),
    }
    match median(&v) {
        Some(x) => println!("Median: {:?}", x),
        None => println!("Not possible to process the Median of this Vec<T>."),
    }
    match mode(&v) {
        Some(x) => println!("Modes: {:?}", x),
        None => println!("Not possible to process the Modes of this Vec<T>."),
    }

    println!();
}

pub fn mean(v: &Vec<i32>) -> Option<f64> {
    if v.len() == 0 {
        return None
    }

    let mut sum = 0;
    for elem in v {
        sum += elem;
    }

    let sum = sum as f64;

    Some((sum / v.len() as f64).into())
}

// https://stackoverflow.com/a/29578077
pub fn median(v: &Vec<i32>) -> Option<f64> {
    if v.len() == 0 {
        return None
    }

    let mut v_sorted = vec![0; v.len()];
    v_sorted.copy_from_slice(&v);
    v_sorted.sort();

    if v_sorted.len() % 2 == 0 {
        Some((v_sorted[(v_sorted.len() / 2) - 1] + v_sorted[(v_sorted.len() / 2) - 1]) as f64 / 2.)
    } else {
        Some(v_sorted[v_sorted.len() / 2].into())
    }
}

pub fn mode(v: &Vec<i32>) -> Option<i32> {
    if v.len() == 0 {
        return None
    }

    let mut map = HashMap::new();
    for elem in v {
        let count = map.entry(elem).or_insert(0);
        *count += 1;
    }

    let mut mode_key = 0;
    let mut mode_val = 0;

    for (key, val) in map.iter() {
        if val > &mode_val {
            mode_key = **key;
            mode_val = *val;
        }
    }

    Some(mode_key)
}
